	include "Os.h"
	xdef	_ti89
	xdef	_ti92plus
	xdef	_main
	xdef	_nostub

STR_TAG	equ	$2D
Trap4Address	equ	$90

_main:
	movem.l	d0-d7/a0-a6,-(a7)
	move.l		Trap4Address,a0
	cmp.l		#'run ',-(a0)
	bne		NotInstalled
	cmp.l		#'Auto',-(a0)
	beq		AlreadyInstalled

NotInstalled:
	ROM_CALL2 	top_estack
	move.l		(a4),a0
;On regarde si l'argument est un chaine de caractre
	cmp.b		#STR_TAG,(a0)
	bne		bad_arg_error
	subq.l		#1,a0
loop_search_start:
	tst.b		-(a0)
	bne		loop_search_start

	lea		Text(pc),a1
	addq.l		#1,a0
loop_copy_text:
	move.b		(a0)+,(a1)+
	bne		loop_copy_text

	movem.l	d0-d7/a0-a6,-(a7)
	pea		Text(pc)
	ROM_CALL	push_parse_text
	addq.l		#4,a7
	movem.l	(a7)+,d0-d7/a0-a6

	move.l		Trap4Address,OldTrap
	move.l		#EndNewTrap-NewTrap,d6
	move.l		d6,-(a7)
	ROM_CALL	HeapAllocHigh
	move.w		d0,(a7)
	ROM_CALL	HeapDeref
	addq.l		#4,a7
	add.l		#$40000,a0
	move.l		a0,a5

	lea		NewTrap(pc),a1
	subq.l		#1,d6
loop_copy_tsr:
	move.b		(a1)+,(a0)+
	dbf		d6,loop_copy_tsr

	bclr.b		#2,$600001
	lea		12(a5),a5
	move.l		a5,Trap4Address
	bset		#2,$600001

	pea		Success(pc)
	bra		affmsg

bad_arg_error:
	pea		BadArgError(pc)
affmsg	ROM_CALL	ST_helpMsg
	addq.l		#4,a7
	movem.l	(a7)+,a0-a6/d0-d7
	rts

AlreadyInstalled:
	ROM_CALL2 	top_estack
	move.l		(a4),a1
;On regarde si l'argument est un chaine de caractre
	cmp.b		#STR_TAG,(a1)
	beq		ChangeText

	bclr.b		#2,$600001
	move.l		-(a0),Trap4Address
	bset		#2,$600001

	sub.l		#$40000,a0
	move.l		a0,-(a7)
	ROM_CALL	HeapPtrToHandle
	move.w		d0,(a7)
	ROM_CALL	HeapFree
	addq.l		#4,a7

	pea		Uninstalled(pc)
	bra		affmsg

ChangeText:
	subq.l		#1,a1
loop_search_start2:
	tst.b		-(a1)
	bne		loop_search_start2

	add.l		#Text-Signature,a0
	addq.l		#1,a1

	movem.l	d0-d7/a0-a6,-(a7)
	move.l		a1,-(a7)
	ROM_CALL	push_parse_text
	addq.l		#4,a7
	movem.l	(a7)+,d0-d7/a0-a6

loop_copy_text2:
	move.b		(a1)+,(a0)+
	bne		loop_copy_text2

	pea		Changement(pc)
	bra		affmsg

BadArgError	dc.b	"Erreur: mauvais argument",0
Success	dc.b	"Programme install avec succs",0
Uninstalled	dc.b	"Programme desinstalle!",0
Changement	dc.b	"Update realise avec succes",0

	EVEN
NewTrap:
OldTrap	dc.l	0
Signature	dc.b	"Autorun "

	move.w		d0,-(a7)
	move.w		sr,d0
	and.w		#$700,d0
	bne		NormalTrapD0
	move.w		(a7)+,d0

	move.l		a0,-(a7)
	lea		InUse(PC),a0
	tst.w		(a0)
	bne		NormalTrapA0
	move.w		#1,(a0)
	move.l		(a7)+,a0

	move.l		a0,-(a7)
	lea		AddrProg(pc),a0
	move.l		6(a7),(a0)
	lea		Suite(pc),a0
	move.l		a0,6(a7)
	move.l		(a7)+,a0
	move.l		OldTrap(pc),-(a7)
	rts

Suite	movem.l	a0-a6/d0-d7,-(a7)

	lea		-60(a7),a7
	move.l 	a7,-(a7)
	ROM_CALL	ER_catch
	tst.b		d0
	bne		Error

	pea		Text(pc)
	ROM_CALL	push_parse_text
;Text transform
	clr.w		(a7)
	ROM_CALL	HS_popEStack
	move.w		d0,-(a7)
	ROM_CALL	NG_execute
	ROM_CALL	HeapFree

	ROM_CALL	ER_success
	lea		70(a7),a7

Continue:
	lea		InUse(pc),a0
	clr.w		(a0)

	movem.l	(a7)+,a0-a6/d0-d7
	move.l		AddrProg(pc),-(a7)
	rts

Error	lea		64(a7),a7
	move.w		d0,-(a7)
	ROM_CALL	find_error_message
	move.l		#$40000,-(a7)
	move.l		a0,-(a7)
	pea		ErrorTitle(PC)
	ROM_CALL	DlgMessage
	lea		14(a7),a7
	bra		Continue

NormalTrapD0:
	move.w		(a7)+,d0
	move.l		OldTrap(pc),-(a7)
	rts

NormalTrapA0:
	move.l		(a7)+,a0
	move.l		OldTrap(pc),-(a7)
	rts

InUse		dc.w	0
AddrProg	dc.l	0
Text		dcb.b	256,0
ErrorTitle	dc.b	"ERROR",0
EndNewTrap
		dc.l	0
	end